const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const teams = sequelize.define(
    'teams',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

slug: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_personal: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  teams.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity








    db.teams.hasMany(db.integrations, {
      as: 'integrations_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });


    db.teams.hasMany(db.user_stories, {
      as: 'user_stories_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });



    db.teams.hasMany(db.documents, {
      as: 'documents_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });


    db.teams.hasMany(db.document_folders, {
      as: 'document_folders_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });









    db.teams.hasMany(db.approval_workflows, {
      as: 'approval_workflows_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });




    db.teams.hasMany(db.audit_events, {
      as: 'audit_events_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });



    db.teams.hasMany(db.sprints, {
      as: 'sprints_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });



    db.teams.hasMany(db.blockers, {
      as: 'blockers_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });


    db.teams.hasMany(db.activity_feed_items, {
      as: 'activity_feed_items_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });


    db.teams.hasMany(db.ai_generations, {
      as: 'ai_generations_team',
      foreignKey: {
          name: 'teamId',
      },
      constraints: false,
    });



//end loop



    db.teams.belongsTo(db.users, {
      as: 'owner',
      foreignKey: {
        name: 'ownerId',
      },
      constraints: false,
    });

    db.teams.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.teams.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.teams.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return teams;
};


